/* T Y P E   D E S C R I P T O R   S T R U C T U R E */

/* $Header$ */

struct paramlist {		/* structure for parameterlist of a PROCEDURE */
	struct paramlist *next;
	struct type *par_type;	/* Parameter type */
	int par_var;		/* flag, set if VAR parameter */
};

/* ALLOCDEF "paramlist" */

struct enume {
	struct def *en_enums;	/* Definitions of enumeration literals */
	unsigned int en_ncst;	/* Number of constants */
	label en_rck;		/* Label of range check descriptor */
#define enm_enums	tp_value.tp_enum.en_enums
#define enm_ncst	tp_value.tp_enum.en_ncst
#define enm_rck		tp_value.tp_enum.enm_rck
};

struct subrange {
	arith su_lb, su_ub;	/* Lower bound and upper bound */
	label su_rck;		/* Label of range check descriptor */
#define sub_lb	tp_value.tp_subrange.su_lb
#define sub_ub	tp_value.tp_subrange.su_ub
#define sub_rck	tp_value.tp_subrange.su_rck
};

struct array {
	struct type *ar_elem;	/* Type of elements */
	arith ar_lb, ar_ub;	/* Lower bound and upper bound */
	label ar_descr;		/* Label of array descriptor */
#define arr_elem	tp_value.tp_arr.ar_elem
#define arr_lb		tp_value.tp_arr.ar_lb
#define arr_ub		tp_value.tp_arr.ar_ub
#define arr_descr	tp_value.tp_arr.ar_descr
};

struct record {
	struct scope *rc_scope;	/* scope of this record */
				/* members are in the symbol table */
#define rec_scope	tp_value.tp_record.rc_scope
};

struct proc {
	struct paramlist *pr_params;
#define prc_params	tp_value.tp_proc.pr_params
};

struct type	{
	struct type *next;	/* used with ARRAY, PROCEDURE, POINTER, SET,
				   SUBRANGE
				*/
	int tp_fund;		/* fundamental type  or constructor */
#define T_RECORD	0x0001
#define	T_ENUMERATION	0x0002
#define	T_INTEGER	0x0004
#define T_CARDINAL	0x0008
/* #define T_LONGINT	0x0010 */
#define T_REAL		0x0020
/* #define T_LONGREAL	0x0040 */
#define T_POINTER	0x0080
#define T_CHAR		0x0100
#define T_WORD		0x0200
#define T_SET		0x0400
#define T_SUBRANGE	0x0800
#define T_PROCEDURE	0x1000
#define T_ARRAY		0x2000
#define T_STRING	0x4000
#define T_INTORCARD	(T_INTEGER|T_CARDINAL)
#define T_DISCRETE	(T_ENUMERATION|T_INTORCARD|T_CHAR)
#define T_NUMERIC	(T_INTORCARD|T_REAL)
#define T_INDEX		(T_ENUMERATION|T_CHAR|T_SUBRANGE)
	int tp_align;		/* alignment requirement of this type */
	arith tp_size;		/* size of this type */
	union {
	    struct enume tp_enum;
	    struct subrange tp_subrange;
	    struct array tp_arr;
	    struct record tp_record;
	    struct proc tp_proc;
	} tp_value;
};

/* ALLOCDEF "type" */

extern struct type
	*bool_type,
	*char_type,
	*charc_type,
	*int_type,
	*card_type,
	*longint_type,
	*real_type,
	*longreal_type,
	*word_type,
	*address_type,
	*intorcard_type,
	*string_type,
	*bitset_type,
	*std_type,
	*error_type;		/* All from type.c */

extern int
	word_align,
	int_align,
	long_align,
	float_align,
	double_align,
	pointer_align,
	struct_align;		/* All from type.c */

extern arith
	word_size,
	int_size,
	long_size,
	float_size,
	double_size,
	pointer_size;		/* All from type.c */

extern arith
	align();		/* type.c */

struct type
	*create_type(),
	*construct_type(),
	*standard_type(),
	*set_type(),
	*subr_type();	/* All from type.c */

#define NULLTYPE ((struct type *) 0)
